#! /usr/bin/env python

import sys
url = sys.argv[1]

import socket
socket.setdefaulttimeout(30)

from cgi import parse_qsl
import urllib
from m_lib.defenc import default_encoding

protocol, request = urllib.splittype(url)
user, password, port = None, None, None
host, path = urllib.splithost(request)
if host:
   user, host = urllib.splituser(host)
   if user:
      user, password = urllib.splitpasswd(user)
   host, port = urllib.splitport(host)
   if port: port = int(port)
path, tag = urllib.splittag(path)
path, query = urllib.splitquery(path)
path = urllib.unquote(path)
if tag: tag = urllib.unquote_plus(tag)

if query:
   qlist = []
   for name, value in parse_qsl(query):
       qlist.append((name, value))

url = ''
host = host.decode(default_encoding).encode('idna')
if path:
   url += urllib.quote(path)
if query:
   url += '?' + urllib.urlencode(qlist)
if tag:
   url += '#' + urllib.quote_plus(tag)

import httplib
server = httplib.HTTP(host, port)
server.set_debuglevel(1)

server.putrequest("HEAD", path)
if port:
    server.putheader("Host", '%s:%d' % (host, port))
else:
   server.putheader("Host", host)

# I remember seeing some sites that return broken HTML or even HTTP response
# without "compatible" user agent; I don't know if such sites are still around,
# but this header doesn't cause any harm so I'd better continue to use it.
# UPDATE: I saw a number of sites that forbid "Mozilla compatible"
client_version = "Python-urllib/%s" % urllib.__version__
server.putheader('User-agent', client_version)

server.putheader('Accept-Charset', "koi8-r;q=1.0")
server.endheaders()

server.getreply()
