#! /usr/bin/env python
"iconv wrapper"

import sys
from getopt import getopt

options, arguments = getopt(sys.argv[1:], 'f:t:')

from_charset = to_charset = None

for option, value in options:
   if option == '-f':
      from_charset = value
   elif option == '-t':
      to_charset = value


if from_charset is None:
   raise ValueError, "you must use -f param to name source charset"

if to_charset is None:
   raise ValueError, "you must use -t param to name destination charset"


import tempfile, os, shutil
tempfname = "_iconvx" + tempfile.gettempprefix() + "tmp"

if arguments:
   try:
         for file in arguments:
            os.system("iconv.py -f '%s' -t '%s' '%s' > '%s'" % (from_charset, to_charset, file, tempfname))
            shutil.copy2(tempfname, file)
   finally:
      os.unlink(tempfname)

else: # filter stdin => stdout
   os.system("iconv.py -f '%s' -t '%s'" % (from_charset, to_charset))
